/*
 * Licensed Materials - Property of IBM pidnumber (C) Copyright IBM Corporation
 * 2005. All Rights Reserved. US Government Users Restricted Rights- Use,
 * duplication or disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 */
package com.ibm.j2ca.sample.twineball.emd.discovery.connection;

import com.ibm.j2ca.extension.emd.PropertyNameHelper;
import com.ibm.j2ca.extension.emd.discovery.WBIMetadataDiscoveryImpl;
import com.ibm.j2ca.extension.emd.discovery.properties.WBIPropertyGroupImpl;
import com.ibm.j2ca.extension.emd.discovery.properties.WBISingleValuedPropertyImpl;
import com.ibm.j2ca.extension.emd.internal.DisplayNameHelper;
import com.ibm.j2ca.extension.logging.LogUtils;

import commonj.connector.metadata.MetadataException;
import commonj.connector.metadata.discovery.properties.PropertyGroup;

/**
 * This is a convenience class to share property setup among outbound and inbound.
 */
public class TwineBallConfigurationProperties {
    
    public static WBIPropertyGroupImpl getTwineBallConfigurationProperties(PropertyNameHelper helper) throws MetadataException {
    	WBIPropertyGroupImpl propGroup = new WBIPropertyGroupImpl("Connection Properties", helper);
        propGroup.setDisplayName(helper.getPropertyName("ConnectionProperties"));
        propGroup.setDescription(helper.getPropertyDescription("ConnectionProperties"));
        WBIPropertyGroupImpl serverInfo = new WBIPropertyGroupImpl("Server Information", helper);
        serverInfo.setDisplayName(helper.getPropertyName("ServerInformation"));
        serverInfo.setDescription(helper.getPropertyDescription("ServerInformation"));
        WBISingleValuedPropertyImpl prop1 = new WBISingleValuedPropertyImpl("Url", String.class, helper);
        prop1.setDisplayName(helper.getPropertyName("Url"));
        prop1.setDescription(helper.getPropertyDescription("Url"));
        prop1.setRequired(false);
        serverInfo.addProperty(prop1);
        prop1 = new WBISingleValuedPropertyImpl("Schema", String.class,helper);
        prop1.setDisplayName(helper.getPropertyName("Schema"));
        prop1.setDescription(helper.getPropertyDescription("Schema"));
        prop1.setRequired(false);
        serverInfo.addProperty(prop1);
        WBIPropertyGroupImpl pg2 = new WBIPropertyGroupImpl("UserCredentials", helper);
        pg2.setDisplayName(helper.getPropertyName("UserCredentials"));
        pg2.setDescription(helper.getPropertyDescription("UserCredentials"));
        WBISingleValuedPropertyImpl prop = new WBISingleValuedPropertyImpl("UserName", String.class, helper);
        prop.setRequired(false);
        prop.setDisplayName(helper.getPropertyName("UserName"));
        prop.setDescription(helper.getPropertyDescription("UserName"));
        pg2.addProperty(prop);
        prop = new WBISingleValuedPropertyImpl("Password", String.class, helper);
        prop.setRequired(false);
        prop.setSensitive(true); //show it as **** on display
        prop.setDisplayName(helper.getPropertyName("Password"));
        prop.setDescription(helper.getPropertyDescription("Password"));
        pg2.addProperty(prop);
        propGroup.addProperty(serverInfo);
        propGroup.addProperty(pg2);
	propGroup.setExpert(true);
        return propGroup;
    }
    /**
     * @param pg
     */
    public static String getLocation(PropertyGroup pg) {
        String location = "";
		WBISingleValuedPropertyImpl locationProp = (WBISingleValuedPropertyImpl) pg
		.getProperty("RelativePath");
		if (locationProp.getValue() != null && !locationProp.getValue().equals(""))
			location = location + (String) locationProp.getValue();
		if (!location.endsWith("/"))
			location = location + "/";
		return location;
    }
    
}